#!/bin/bash

rootdn="cn=directory manager"
rootpw=Secret12

# Enable memberOf plug-in
echo "Enabling memberOf plug-in ..."
ldapmodify -x -D "$rootdn" -w $rootpw << EOF
dn: cn=MemberOf Plugin,cn=plugins,cn=config
changetype: modify
replace: nsslapd-pluginEnabled
nsslapd-pluginEnabled: on
EOF

# Restart DS to load the memberOf plug-in
echo "Restarting dirsrv instance ..."
service dirsrv restart

# Add large-group
echo "Adding test group ..."
ldapmodify -x -D "$rootdn" -w $rootpw << EOF
dn: cn=large-group,dc=example,dc=com
changetype: add
objectclass: groupOfNames
EOF

# Loop through addition of users, adding membership, and dereferencing the group members
for i in `seq 1 3000`; do
    echo "Adding user $i ..."
    ldapmodify -x -D "$rootdn" -w $rootpw << EOF
dn: uid=user$i,dc=example,dc=com
changetype: add
objectclass: posixAccount
objectclass: inetUser
cn: User $i
homeDirectory: /home/user$i
uidNumber: 500
gidNumber: 500
EOF

    echo "Adding user $i to large-group ..."
    ./dshang.pl $i
done

